'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var ctXeokitViewer = require('ct-xeokit-viewer');
var ctXeokitSharedPluginLib = require('ct-xeokit-shared-plugin-lib');

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _superPropBase(object, property) {
  while (!Object.prototype.hasOwnProperty.call(object, property)) {
    object = _getPrototypeOf(object);
    if (object === null) break;
  }

  return object;
}

function _get() {
  if (typeof Reflect !== "undefined" && Reflect.get) {
    _get = Reflect.get;
  } else {
    _get = function _get(target, property, receiver) {
      var base = _superPropBase(target, property);
      if (!base) return;
      var desc = Object.getOwnPropertyDescriptor(base, property);

      if (desc.get) {
        return desc.get.call(arguments.length < 3 ? target : receiver);
      }

      return desc.value;
    };
  }

  return _get.apply(this, arguments);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _typeof(obj) {
  "@babel/helpers - typeof";

  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    _typeof = function _typeof(obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function _possibleConstructorReturn(self, call) {
  if (call && (_typeof(call) === "object" || typeof call === "function")) {
    return call;
  } else if (call !== void 0) {
    throw new TypeError("Derived constructors may only return object or undefined");
  }

  return _assertThisInitialized(self);
}

function _createSuper$2(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$2(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct$2() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var distVec3 = ctXeokitViewer.math.vec3();

var lengthWire = function lengthWire(x1, y1, x2, y2) {
  var a = x1 - x2;
  var b = y1 - y2;
  return Math.sqrt(a * a + b * b);
};
/**
 * @desc Measures the distance between two 3D points.
 *
 * See {@link DistanceMeasurementsPlugin} for more info.
 */


var DistanceMeasurement = /*#__PURE__*/function (_Component) {
  _inherits(DistanceMeasurement, _Component);

  var _super = _createSuper$2(DistanceMeasurement);

  /**
   * @private
   */
  function DistanceMeasurement(plugin) {
    var _this;

    var cfg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, DistanceMeasurement);

    _this = _super.call(this, plugin.viewer.scene, cfg);
    /**
     * The {@link DistanceMeasurementsPlugin} that owns this DistanceMeasurement.
     * @type {DistanceMeasurementsPlugin}
     */

    _this.plugin = plugin;
    _this._container = cfg.container;

    if (!_this._container) {
      throw "config missing: container";
    }

    _this._eventSubs = {};
    var scene = _this.plugin.viewer.scene;
    _this._originMarker = new ctXeokitViewer.Marker(scene, cfg.origin);
    _this._targetMarker = new ctXeokitViewer.Marker(scene, cfg.target);
    _this._originWorld = ctXeokitViewer.math.vec3();
    _this._targetWorld = ctXeokitViewer.math.vec3();
    _this._wp = new Float64Array(24);
    _this._vp = new Float64Array(24);
    _this._pp = new Float64Array(24);
    _this._cp = new Int16Array(8);
    _this._xAxisLabelCulled = false;
    _this._yAxisLabelCulled = false;
    _this._zAxisLabelCulled = false;
    _this._color = cfg.color || _this.plugin.defaultColor;
    _this._originDot = new ctXeokitSharedPluginLib.Dot(_this._container, {
      fillColor: _this._color,
      zIndex: plugin.zIndex !== undefined ? plugin.zIndex + 2 : undefined
    });
    _this._targetDot = new ctXeokitSharedPluginLib.Dot(_this._container, {
      fillColor: _this._color,
      zIndex: plugin.zIndex !== undefined ? plugin.zIndex + 2 : undefined
    });
    _this._lengthWire = new ctXeokitSharedPluginLib.Wire(_this._container, {
      color: _this._color,
      thickness: 2,
      zIndex: plugin.zIndex !== undefined ? plugin.zIndex + 1 : undefined
    });
    _this._xAxisWire = new ctXeokitSharedPluginLib.Wire(_this._container, {
      color: "red",
      thickness: 1,
      zIndex: plugin.zIndex !== undefined ? plugin.zIndex + 1 : undefined
    });
    _this._yAxisWire = new ctXeokitSharedPluginLib.Wire(_this._container, {
      color: "green",
      thickness: 1,
      zIndex: plugin.zIndex !== undefined ? plugin.zIndex + 1 : undefined
    });
    _this._zAxisWire = new ctXeokitSharedPluginLib.Wire(_this._container, {
      color: "blue",
      thickness: 1,
      zIndex: plugin.zIndex !== undefined ? plugin.zIndex + 1 : undefined
    });
    _this._lengthLabel = new ctXeokitSharedPluginLib.Label(_this._container, {
      fillColor: _this._color,
      prefix: "",
      text: "",
      zIndex: plugin.zIndex !== undefined ? plugin.zIndex + 4 : undefined
    });
    _this._xAxisLabel = new ctXeokitSharedPluginLib.Label(_this._container, {
      fillColor: "red",
      prefix: "X",
      text: "",
      zIndex: plugin.zIndex !== undefined ? plugin.zIndex + 3 : undefined
    });
    _this._yAxisLabel = new ctXeokitSharedPluginLib.Label(_this._container, {
      fillColor: "green",
      prefix: "Y",
      text: "",
      zIndex: plugin.zIndex !== undefined ? plugin.zIndex + 3 : undefined
    });
    _this._zAxisLabel = new ctXeokitSharedPluginLib.Label(_this._container, {
      fillColor: "blue",
      prefix: "Z",
      text: "",
      zIndex: plugin.zIndex !== undefined ? plugin.zIndex + 3 : undefined
    });
    _this._wpDirty = false;
    _this._vpDirty = false;
    _this._cpDirty = false;
    _this._visible = false;
    _this._originVisible = false;
    _this._targetVisible = false;
    _this._wireVisible = false;
    _this._axisVisible = false;
    _this._axisEnabled = true;

    _this._originMarker.on("worldPos", function (value) {
      _this._originWorld.set(value || [0, 0, 0]);

      _this._wpDirty = true;

      _this._needUpdate(0); // No lag

    });

    _this._targetMarker.on("worldPos", function (value) {
      _this._targetWorld.set(value || [0, 0, 0]);

      _this._wpDirty = true;

      _this._needUpdate(0); // No lag

    });

    _this._onViewMatrix = scene.camera.on("viewMatrix", function () {
      _this._vpDirty = true;

      _this._needUpdate(0); // No lag

    });
    _this._onProjMatrix = scene.camera.on("projMatrix", function () {
      _this._cpDirty = true;

      _this._needUpdate();
    });
    _this._onCanvasBoundary = scene.canvas.on("boundary", function () {
      _this._cpDirty = true;

      _this._needUpdate(0); // No lag

    });
    _this._onMetricsUnits = scene.metrics.on("units", function () {
      _this._cpDirty = true;

      _this._needUpdate();
    });
    _this._onMetricsScale = scene.metrics.on("scale", function () {
      _this._cpDirty = true;

      _this._needUpdate();
    });
    _this._onMetricsOrigin = scene.metrics.on("origin", function () {
      _this._cpDirty = true;

      _this._needUpdate();
    });
    _this.approximate = cfg.approximate;
    _this.visible = cfg.visible;
    _this.originVisible = cfg.originVisible;
    _this.targetVisible = cfg.targetVisible;
    _this.wireVisible = cfg.wireVisible;
    _this.axisVisible = cfg.axisVisible;
    return _this;
  }

  _createClass(DistanceMeasurement, [{
    key: "_update",
    value: function _update() {
      if (!this._visible) {
        return;
      }

      var scene = this.plugin.viewer.scene;

      if (this._wpDirty) {
        this._wp[0] = this._originWorld[0];
        this._wp[1] = this._originWorld[1];
        this._wp[2] = this._originWorld[2];
        this._wp[3] = 1.0;
        this._wp[4] = this._targetWorld[0];
        this._wp[5] = this._originWorld[1];
        this._wp[6] = this._originWorld[2];
        this._wp[7] = 1.0;
        this._wp[8] = this._targetWorld[0];
        this._wp[9] = this._targetWorld[1];
        this._wp[10] = this._originWorld[2];
        this._wp[11] = 1.0;
        this._wp[12] = this._targetWorld[0];
        this._wp[13] = this._targetWorld[1];
        this._wp[14] = this._targetWorld[2];
        this._wp[15] = 1.0;
        this._wpDirty = false;
        this._vpDirty = true;
      }

      if (this._vpDirty) {
        ctXeokitViewer.math.transformPositions4(scene.camera.viewMatrix, this._wp, this._vp);
        this._vp[3] = 1.0;
        this._vp[7] = 1.0;
        this._vp[11] = 1.0;
        this._vp[15] = 1.0;
        this._vpDirty = false;
        this._cpDirty = true;
      }

      var near = -0.3;
      var vpz1 = this._originMarker.viewPos[2];
      var vpz2 = this._targetMarker.viewPos[2];

      if (vpz1 > near || vpz2 > near) {
        this._xAxisLabel.setVisible(false);

        this._yAxisLabel.setVisible(false);

        this._zAxisLabel.setVisible(false);

        this._lengthLabel.setVisible(false);

        this._xAxisWire.setVisible(false);

        this._yAxisWire.setVisible(false);

        this._zAxisWire.setVisible(false);

        this._lengthWire.setVisible(false);

        this._originDot.setVisible(false);

        this._targetDot.setVisible(false);

        return;
      }

      if (this._cpDirty) {
        ctXeokitViewer.math.transformPositions4(scene.camera.project.matrix, this._vp, this._pp);
        var pp = this._pp;
        var cp = this._cp;
        var canvas = scene.canvas.canvas;
        var offsets = canvas.getBoundingClientRect();

        var containerOffsets = this._container.getBoundingClientRect();

        var top = offsets.top - containerOffsets.top;
        var left = offsets.left - containerOffsets.left;
        var aabb = scene.canvas.boundary;
        var canvasWidth = aabb[2];
        var canvasHeight = aabb[3];
        var j = 0;
        var metrics = this.plugin.viewer.scene.metrics;
        var scale = metrics.scale;
        var units = metrics.units;
        var unitInfo = metrics.unitsInfo[units];
        var unitAbbrev = unitInfo.abbrev;

        for (var i = 0, len = pp.length; i < len; i += 4) {
          cp[j] = left + Math.floor((1 + pp[i + 0] / pp[i + 3]) * canvasWidth / 2);
          cp[j + 1] = top + Math.floor((1 - pp[i + 1] / pp[i + 3]) * canvasHeight / 2);
          j += 2;
        }

        this._originDot.setPos(cp[0], cp[1]);

        this._targetDot.setPos(cp[6], cp[7]);

        this._lengthWire.setStartAndEnd(cp[0], cp[1], cp[6], cp[7]);

        this._xAxisWire.setStartAndEnd(cp[0], cp[1], cp[2], cp[3]);

        this._yAxisWire.setStartAndEnd(cp[2], cp[3], cp[4], cp[5]);

        this._zAxisWire.setStartAndEnd(cp[4], cp[5], cp[6], cp[7]);

        this._lengthLabel.setPosOnWire(cp[0], cp[1], cp[6], cp[7]);

        this._xAxisLabel.setPosOnWire(cp[0], cp[1], cp[2], cp[3]);

        this._yAxisLabel.setPosOnWire(cp[2], cp[3], cp[4], cp[5]);

        this._zAxisLabel.setPosOnWire(cp[4], cp[5], cp[6], cp[7]);

        var tilde = this._approximate ? " ~ " : " = ";
        this._length = Math.abs(ctXeokitViewer.math.lenVec3(ctXeokitViewer.math.subVec3(this._targetWorld, this._originWorld, distVec3)));

        this._lengthLabel.setText(tilde + (this._length * scale).toFixed(2) + unitAbbrev);

        var xAxisCanvasLength = Math.abs(lengthWire(cp[0], cp[1], cp[2], cp[3]));
        var yAxisCanvasLength = Math.abs(lengthWire(cp[2], cp[3], cp[4], cp[5]));
        var zAxisCanvasLength = Math.abs(lengthWire(cp[4], cp[5], cp[6], cp[7]));
        var labelMinAxisLength = this.plugin.labelMinAxisLength;
        this._xAxisLabelCulled = xAxisCanvasLength < labelMinAxisLength;
        this._yAxisLabelCulled = yAxisCanvasLength < labelMinAxisLength;
        this._zAxisLabelCulled = zAxisCanvasLength < labelMinAxisLength;

        if (!this._xAxisLabelCulled) {
          this._xAxisLabel.setText(tilde + Math.abs((this._targetWorld[0] - this._originWorld[0]) * scale).toFixed(2) + unitAbbrev);

          this._xAxisLabel.setVisible(this.axisVisible);
        } else {
          this._xAxisLabel.setVisible(false);
        }

        if (!this._yAxisLabelCulled) {
          this._yAxisLabel.setText(tilde + Math.abs((this._targetWorld[1] - this._originWorld[1]) * scale).toFixed(2) + unitAbbrev);

          this._yAxisLabel.setVisible(this.axisVisible);
        } else {
          this._yAxisLabel.setVisible(false);
        }

        if (!this._zAxisLabelCulled) {
          this._zAxisLabel.setText(tilde + Math.abs((this._targetWorld[2] - this._originWorld[2]) * scale).toFixed(2) + unitAbbrev);

          this._zAxisLabel.setVisible(this.axisVisible);
        } else {
          this._zAxisLabel.setVisible(false);
        }

        this._originDot.setVisible(this._visible && this._originVisible);

        this._targetDot.setVisible(this._visible && this._targetVisible);

        this._xAxisWire.setVisible(this.axisVisible);

        this._yAxisWire.setVisible(this.axisVisible);

        this._zAxisWire.setVisible(this.axisVisible);

        this._lengthWire.setVisible(this.wireVisible);

        this._lengthLabel.setVisible(this.wireVisible);

        this._cpDirty = false;
      }
    }
    /**
     * Sets whether this DistanceMeasurement indicates that its measurement is approximate.
     *
     * This is ````true```` by default.
     *
     * @type {Boolean}
     */

  }, {
    key: "approximate",
    get:
    /**
     * Gets whether this DistanceMeasurement indicates that its measurement is approximate.
     *
     * This is ````true```` by default.
     *
     * @type {Boolean}
     */
    function get() {
      return this._approximate;
    }
    /**
     * Gets the origin {@link Marker}.
     *
     * @type {Marker}
     */
    ,
    set: function set(approximate) {
      approximate = approximate !== false;

      if (this._approximate === approximate) {
        return;
      }

      this._approximate = approximate;
      this._cpDirty = true;

      this._needUpdate(0);
    }
  }, {
    key: "origin",
    get: function get() {
      return this._originMarker;
    }
    /**
     * Gets the target {@link Marker}.
     *
     * @type {Marker}
     */

  }, {
    key: "target",
    get: function get() {
      return this._targetMarker;
    }
    /**
     * Gets the World-space direct point-to-point distance between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target}.
     *
     * @type {Number}
     */

  }, {
    key: "length",
    get: function get() {
      this._update();

      var scale = this.plugin.viewer.scene.metrics.scale;
      return this._length * scale;
    }
  }, {
    key: "color",
    get: function get() {
      return this._color;
    },
    set: function set(value) {
      this._color = value;

      this._originDot.setFillColor(value);

      this._targetDot.setFillColor(value);

      this._lengthWire.setColor(value);

      this._lengthLabel.setFillColor(value);
    }
    /**
     * Sets whether this DistanceMeasurement is visible or not.
     *
     * @type {Boolean}
     */

  }, {
    key: "visible",
    get:
    /**
     * Gets whether this DistanceMeasurement is visible or not.
     *
     * @type {Boolean}
     */
    function get() {
      return this._visible;
    }
    /**
     * Sets if the origin {@link Marker} is visible.
     *
     * @type {Boolean}
     */
    ,
    set: function set(value) {
      value = value !== undefined ? Boolean(value) : this.plugin.defaultVisible;
      this._visible = value;

      this._originDot.setVisible(this._visible && this._originVisible);

      this._targetDot.setVisible(this._visible && this._targetVisible);

      this._lengthWire.setVisible(this._visible && this._wireVisible);

      this._lengthLabel.setVisible(this._visible && this._wireVisible);

      var axisVisible = this._visible && this._axisVisible;

      this._xAxisWire.setVisible(axisVisible);

      this._yAxisWire.setVisible(axisVisible);

      this._zAxisWire.setVisible(axisVisible);

      this._xAxisLabel.setVisible(axisVisible && !this._xAxisLabelCulled);

      this._yAxisLabel.setVisible(axisVisible && !this._yAxisLabelCulled);

      this._zAxisLabel.setVisible(axisVisible && !this._zAxisLabelCulled);
    }
  }, {
    key: "originVisible",
    get:
    /**
     * Gets if the origin {@link Marker} is visible.
     *
     * @type {Boolean}
     */
    function get() {
      return this._originVisible;
    }
    /**
     * Sets if the target {@link Marker} is visible.
     *
     * @type {Boolean}
     */
    ,
    set: function set(value) {
      value = value !== undefined ? Boolean(value) : this.plugin.defaultOriginVisible;
      this._originVisible = value;

      this._originDot.setVisible(this._visible && this._originVisible);
    }
  }, {
    key: "targetVisible",
    get:
    /**
     * Gets if the target {@link Marker} is visible.
     *
     * @type {Boolean}
     */
    function get() {
      return this._targetVisible;
    }
    /**
     * Sets if the axis-aligned wires between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target} are visible.
     *
     * @type {Boolean}
     */
    ,
    set: function set(value) {
      value = value !== undefined ? Boolean(value) : this.plugin.defaultTargetVisible;
      this._targetVisible = value;

      this._targetDot.setVisible(this._visible && this._targetVisible);
    }
  }, {
    key: "axisEnabled",
    get:
    /**
     * Gets if the axis-aligned wires between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target} are visible.
     *
     * @type {Boolean}
     */
    function get() {
      return this._axisEnabled;
    }
    /**
     * Sets if the axis-aligned wires between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target} are visible.
     *
     * @type {Boolean}
     */
    ,
    set: function set(value) {
      value = value !== undefined ? Boolean(value) : this.plugin.defaultAxisVisible;
      this._axisEnabled = value;
      var axisVisible = this._visible && this._axisVisible && this._axisEnabled;

      this._xAxisWire.setVisible(axisVisible);

      this._yAxisWire.setVisible(axisVisible);

      this._zAxisWire.setVisible(axisVisible);

      this._xAxisLabel.setVisible(axisVisible && !this._xAxisLabelCulled);

      this._yAxisLabel.setVisible(axisVisible && !this._yAxisLabelCulled);

      this._zAxisLabel.setVisible(axisVisible && !this._zAxisLabelCulled);
    }
  }, {
    key: "axisVisible",
    get:
    /**
     * Gets if the axis-aligned wires between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target} are visible.
     *
     * @type {Boolean}
     */
    function get() {
      return this._axisVisible;
    }
    /**
     * Sets if the direct point-to-point wire between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target} is visible.
     *
     * @type {Boolean}
     */
    ,
    set: function set(value) {
      value = value !== undefined ? Boolean(value) : this.plugin.defaultAxisVisible;
      this._axisVisible = value;
      var axisVisible = this._visible && this._axisVisible && this._axisEnabled;

      this._xAxisWire.setVisible(axisVisible);

      this._yAxisWire.setVisible(axisVisible);

      this._zAxisWire.setVisible(axisVisible);

      this._xAxisLabel.setVisible(axisVisible && !this._xAxisLabelCulled);

      this._yAxisLabel.setVisible(axisVisible && !this._yAxisLabelCulled);

      this._zAxisLabel.setVisible(axisVisible && !this._zAxisLabelCulled);
    }
  }, {
    key: "wireVisible",
    get:
    /**
     * Gets if the direct point-to-point wire between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target} is visible.
     *
     * @type {Boolean}
     */
    function get() {
      return this._wireVisible;
    }
    /**
     * @private
     */
    ,
    set: function set(value) {
      value = value !== undefined ? Boolean(value) : this.plugin.defaultWireVisible;
      this._wireVisible = value;
      var wireVisible = this._visible && this._wireVisible;

      this._lengthLabel.setVisible(wireVisible);

      this._lengthWire.setVisible(wireVisible);
    }
  }, {
    key: "destroy",
    value: function destroy() {
      var scene = this.plugin.viewer.scene;
      var metrics = scene.metrics;

      if (this._onViewMatrix) {
        scene.camera.off(this._onViewMatrix);
      }

      if (this._onProjMatrix) {
        scene.camera.off(this._onProjMatrix);
      }

      if (this._onCanvasBoundary) {
        scene.canvas.off(this._onCanvasBoundary);
      }

      if (this._onMetricsUnits) {
        metrics.off(this._onMetricsUnits);
      }

      if (this._onMetricsScale) {
        metrics.off(this._onMetricsScale);
      }

      if (this._onMetricsOrigin) {
        metrics.off(this._onMetricsOrigin);
      }

      this._originDot.destroy();

      this._targetDot.destroy();

      this._xAxisWire.destroy();

      this._yAxisWire.destroy();

      this._zAxisWire.destroy();

      this._lengthLabel.destroy();

      this._xAxisLabel.destroy();

      this._yAxisLabel.destroy();

      this._zAxisLabel.destroy();

      this._lengthWire.destroy();

      _get(_getPrototypeOf(DistanceMeasurement.prototype), "destroy", this).call(this);
    }
  }]);

  return DistanceMeasurement;
}(ctXeokitViewer.Component);

function _createSuper$1(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct$1(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct$1() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
/**
 * Creates {@link DistanceMeasurement}s from mouse and touch input.
 *
 * Belongs to a {@link DistanceMeasurementsPlugin}. Located at {@link DistanceMeasurementsPlugin#control}.
 *
 * Once the DistanceMeasurementControl is activated, the first click on any {@link Entity} begins constructing a {@link DistanceMeasurement}, fixing its origin to that Entity. The next click on any Entity will complete the DistanceMeasurement, fixing its target to that second Entity. The DistanceMeasurementControl will then wait for the next click on any Entity, to begin constructing another DistanceMeasurement, and so on, until deactivated.
 *
 * See {@link DistanceMeasurementsPlugin} for more info.
 */

var DistanceMeasurementsControl = /*#__PURE__*/function (_Component) {
  _inherits(DistanceMeasurementsControl, _Component);

  var _super = _createSuper$1(DistanceMeasurementsControl);

  /**
   * @private
   */
  function DistanceMeasurementsControl(plugin) {
    var _this;

    _classCallCheck(this, DistanceMeasurementsControl);

    _this = _super.call(this, plugin.viewer.scene);
    /**
     * The {@link DistanceMeasurementsPlugin} that owns this DistanceMeasurementsControl.
     * @type {DistanceMeasurementsPlugin}
     */

    _this.plugin = plugin;
    _this._active = false; // Mouse input uses a combo of events that requires us to track
    // the current DistanceMeasurement under construction. This is not used for touch input.

    _this._currentDistanceMeasurementByMouse = null;
    _this._currentDistanceMeasurementByMouseInittouchState = {
      wireVisible: null,
      axisVisible: null,
      targetVisible: null
    }; // Shows 2D canvas pos of touch start

    _this._touchStartDot = new ctXeokitSharedPluginLib.Dot(plugin._container, {
      fillColor: plugin.defaultColor,
      zIndex: plugin.zIndex + 1,
      visible: false
    }); // Tracks 3D world pos of touch start, dynamically calculates 2D canvas pos

    _this._touchStartMarker = new ctXeokitViewer.Marker(_assertThisInitialized(_this), {
      id: "distanceMeasurementMarker"
    }); // Routes 2D canvas pos from Marker to Dot

    _this._touchStartMarker.on("canvasPos", function (canvasPos) {
      _this._touchStartDot.setPos(canvasPos[0], canvasPos[1]);
    }); // Event handles from CameraControl


    _this._onMouseHoverSurface = null;
    _this._onMouseHoverOff = null;
    _this._onPickedNothing = null; // Event handles from Scene.input

    _this._onInputMouseDown = null;
    _this._onInputMouseUp = null; // Event handles from Canvas element

    _this._onCanvasTouchStart = null;
    _this._onCanvasTouchEnd = null;
    return _this;
  }
  /** Gets if this DistanceMeasurementsControl is currently active, where it is responding to input.
   *
   * @returns {Boolean}
   */


  _createClass(DistanceMeasurementsControl, [{
    key: "active",
    get: function get() {
      return this._active;
    }
    /**
     * Activates this DistanceMeasurementsControl, ready to respond to input.
     */

  }, {
    key: "activate",
    value: function activate() {
      var _this2 = this;

      if (this._active) {
        return;
      }

      var plugin = this.plugin;
      var scene = this.scene;
      var cameraControl = plugin.viewer.cameraControl;
      var canvas = scene.canvas.canvas;
      var input = scene.input;
      var startDot = this._touchStartDot;
      var pickSurfacePrecisionEnabled = scene.pickSurfacePrecisionEnabled;
      var mouseHoverEntity = null;
      var mouseWorldPos = ctXeokitViewer.math.vec3();
      var mouseCanvasPos = ctXeokitViewer.math.vec2();
      var lastMouseCanvasX;
      var lastMouseCanvasY;
      var mouseCanvasClickTolerance = 5;
      var FIRST_TOUCH_EXPECTED = 0;
      var SECOND_TOUCH_EXPECTED = 1;
      var touchState = FIRST_TOUCH_EXPECTED;
      var touchCanvasClickTolerance = 5;
      var touchStartCanvasPos = ctXeokitViewer.math.vec2();
      var touchEndCanvasPos = ctXeokitViewer.math.vec2();
      var touchStartWorldPos = ctXeokitViewer.math.vec3();
      this._onMouseHoverSurface = cameraControl.on("hoverSurface", function (event) {
        // This gets fired for both mouse and touch input, but we don't care when handling touch
        mouseHoverEntity = event.entity;
        mouseWorldPos.set(event.worldPos);
        mouseCanvasPos.set(event.canvasPos);
        canvas.style.cursor = "pointer";

        if (_this2._currentDistanceMeasurementByMouse) {
          _this2._currentDistanceMeasurementByMouse.wireVisible = _this2._currentDistanceMeasurementByMouseInittouchState.wireVisible;
          _this2._currentDistanceMeasurementByMouse.axisVisible = _this2._currentDistanceMeasurementByMouseInittouchState.axisVisible && _this2.plugin.defaultAxisVisible;
          _this2._currentDistanceMeasurementByMouse.targetVisible = _this2._currentDistanceMeasurementByMouseInittouchState.targetVisible;
          _this2._currentDistanceMeasurementByMouse.target.entity = mouseHoverEntity;
          _this2._currentDistanceMeasurementByMouse.target.worldPos = mouseWorldPos;
        }
      });
      this._onInputMouseDown = input.on("mousedown", function (coords) {
        lastMouseCanvasX = coords[0];
        lastMouseCanvasY = coords[1];
      });
      this._onInputMouseUp = input.on("mouseup", function (coords) {
        if (coords[0] > lastMouseCanvasX + mouseCanvasClickTolerance || coords[0] < lastMouseCanvasX - mouseCanvasClickTolerance || coords[1] > lastMouseCanvasY + mouseCanvasClickTolerance || coords[1] < lastMouseCanvasY - mouseCanvasClickTolerance) {
          return;
        }

        if (_this2._currentDistanceMeasurementByMouse) {
          if (mouseHoverEntity) {
            if (pickSurfacePrecisionEnabled) {
              var pickResult = scene.pick({
                canvasPos: mouseCanvasPos,
                pickSurface: true,
                pickSurfacePrecision: true
              });

              if (pickResult && pickResult.worldPos) {
                _this2._currentDistanceMeasurementByMouse.target.worldPos = pickResult.worldPos;
              }

              _this2._currentDistanceMeasurementByMouse.approximate = false;
            }

            _this2.fire("measurementEnd", _this2._currentDistanceMeasurementByMouse);

            _this2._currentDistanceMeasurementByMouse = null;
          } else {
            _this2._currentDistanceMeasurementByMouse.destroy();

            _this2.fire("measurementCancel", _this2._currentDistanceMeasurementByMouse);

            _this2._currentDistanceMeasurementByMouse = null;
          }
        } else {
          if (mouseHoverEntity) {
            if (pickSurfacePrecisionEnabled) {
              var _pickResult = scene.pick({
                canvasPos: mouseCanvasPos,
                pickSurface: true,
                pickSurfacePrecision: true
              });

              if (_pickResult && _pickResult.worldPos) {
                mouseWorldPos.set(_pickResult.worldPos);
              }
            }

            _this2._currentDistanceMeasurementByMouse = plugin.createMeasurement({
              id: ctXeokitViewer.math.createUUID(),
              origin: {
                entity: mouseHoverEntity,
                worldPos: mouseWorldPos
              },
              target: {
                entity: mouseHoverEntity,
                worldPos: mouseWorldPos
              },
              approximate: true
            });
            _this2._currentDistanceMeasurementByMouseInittouchState.axisVisible = _this2._currentDistanceMeasurementByMouse.axisVisible && _this2.plugin.defaultAxisVisible;
            _this2._currentDistanceMeasurementByMouseInittouchState.wireVisible = _this2._currentDistanceMeasurementByMouse.wireVisible;
            _this2._currentDistanceMeasurementByMouseInittouchState.targetVisible = _this2._currentDistanceMeasurementByMouse.targetVisible;

            _this2.fire("measurementStart", _this2._currentDistanceMeasurementByMouse);
          }
        }
      });
      this._onMouseHoverOff = cameraControl.on("hoverOff", function (event) {
        mouseHoverEntity = null;

        if (_this2._currentDistanceMeasurementByMouse) {
          _this2._currentDistanceMeasurementByMouse.wireVisible = false;
          _this2._currentDistanceMeasurementByMouse.targetVisible = false;
          _this2._currentDistanceMeasurementByMouse.axisVisible = false;
        }

        canvas.style.cursor = "default";
      });
      this._onPickedNothing = cameraControl.on("pickedNothing", function (event) {
        if (_this2._currentDistanceMeasurementByMouse) {
          _this2._currentDistanceMeasurementByMouse.destroy();

          _this2._currentDistanceMeasurementByMouse = null;
        }

        startDot.setVisible(false);
        touchState = FIRST_TOUCH_EXPECTED;
      });
      canvas.addEventListener("touchstart", this._onCanvasTouchStart = function (event) {
        var touches = event.touches;
        var changedTouches = event.changedTouches;

        if (touches.length === 1 && changedTouches.length === 1) {
          getCanvasPosFromEvent(touches[0], touchStartCanvasPos);
        }
      }, {
        passive: true
      });
      canvas.addEventListener("touchend", this._onCanvasTouchEnd = function (event) {
        var touches = event.touches;
        var changedTouches = event.changedTouches;

        if (touches.length === 0 && changedTouches.length === 1) {
          getCanvasPosFromEvent(changedTouches[0], touchEndCanvasPos);

          if (touchEndCanvasPos[0] > touchStartCanvasPos[0] + touchCanvasClickTolerance || touchEndCanvasPos[0] < touchStartCanvasPos[0] - touchCanvasClickTolerance || touchEndCanvasPos[1] > touchStartCanvasPos[1] + touchCanvasClickTolerance || touchEndCanvasPos[1] < touchStartCanvasPos[1] - touchCanvasClickTolerance) {
            return; // User is repositioning the camera or model
          }

          var pickResult = scene.pick({
            canvasPos: touchEndCanvasPos,
            pickSurface: true,
            pickSurfacePrecision: pickSurfacePrecisionEnabled
          });

          if (pickResult && pickResult.worldPos) {
            switch (touchState) {
              case FIRST_TOUCH_EXPECTED:
                startDot.setVisible(true);
                _this2._touchStartMarker.worldPos = pickResult.worldPos;
                touchStartWorldPos.set(pickResult.worldPos);
                touchState = SECOND_TOUCH_EXPECTED;
                break;

              case SECOND_TOUCH_EXPECTED:
                startDot.setVisible(false);
                _this2._touchStartMarker.worldPos = pickResult.worldPos;
                plugin.createMeasurement({
                  id: ctXeokitViewer.math.createUUID(),
                  origin: {
                    entity: mouseHoverEntity,
                    worldPos: touchStartWorldPos
                  },
                  target: {
                    entity: mouseHoverEntity,
                    worldPos: pickResult.worldPos
                  },
                  approximate: !pickSurfacePrecisionEnabled
                });
                touchState = FIRST_TOUCH_EXPECTED;
                break;
            }
          } else {
            startDot.setVisible(false);
            touchState = FIRST_TOUCH_EXPECTED;
          }
        } //  event.stopPropagation();

      }, {
        passive: true
      });
      this._active = true;
    }
    /**
     * Deactivates this DistanceMeasurementsControl, making it unresponsive to input.
     *
     * Destroys any {@link DistanceMeasurement} under construction.
     */

  }, {
    key: "deactivate",
    value: function deactivate() {
      if (!this._active) {
        return;
      }

      this._touchStartDot.setVisible(false);

      this.reset();
      var input = this.plugin.viewer.scene.input;
      input.off(this._onInputMouseDown);
      input.off(this._onInputMouseUp);
      var cameraControl = this.plugin.viewer.cameraControl;
      cameraControl.off(this._onMouseHoverSurface);
      cameraControl.off(this._onMouseHoverOff);
      cameraControl.off(this._onPickedNothing);
      var canvas = this.plugin.viewer.scene.canvas.canvas;
      canvas.removeEventListener("touchstart", this._onCanvasTouchStart);
      canvas.removeEventListener("touchend", this._onCanvasTouchEnd);
      this._currentDistanceMeasurementByMouse = null;
      this._active = false;
    }
    /**
     * Resets this DistanceMeasurementsControl.
     *
     * Destroys any {@link DistanceMeasurement} under construction.
     *
     * Does nothing if the DistanceMeasurementsControl is not active.
     */

  }, {
    key: "reset",
    value: function reset() {
      if (!this._active) {
        return;
      }

      if (this._currentDistanceMeasurementByMouse) {
        this._currentDistanceMeasurementByMouse.destroy();

        this._currentDistanceMeasurementByMouse = null;
      }
    }
    /**
     * @private
     */

  }, {
    key: "destroy",
    value: function destroy() {
      this._touchStartDot.destroy();

      this.deactivate();

      _get(_getPrototypeOf(DistanceMeasurementsControl.prototype), "destroy", this).call(this);
    }
  }]);

  return DistanceMeasurementsControl;
}(ctXeokitViewer.Component);

var getCanvasPosFromEvent = function getCanvasPosFromEvent(event, canvasPos) {
  if (!event) {
    event = window.event;
    canvasPos[0] = event.x;
    canvasPos[1] = event.y;
  } else {
    var element = event.target;
    var totalOffsetLeft = 0;
    var totalOffsetTop = 0;

    while (element.offsetParent) {
      totalOffsetLeft += element.offsetLeft;
      totalOffsetTop += element.offsetTop;
      element = element.offsetParent;
    }

    canvasPos[0] = event.pageX - totalOffsetLeft;
    canvasPos[1] = event.pageY - totalOffsetTop;
  }

  return canvasPos;
};

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
/**
 * {@link Viewer} plugin for measuring point-to-point distances.
 *
 * [<img src="https://user-images.githubusercontent.com/83100/63047331-867a0a80-bed4-11e9-892f-398740013c5f.gif">](https://xeokit.github.io/xeokit-sdk/examples/#measurements_distance_createWithMouse)
 *
 * * [[Example 1: Model with distance measurements](https://xeokit.github.io/xeokit-sdk/examples/#measurements_distance_modelWithMeasurements)]
 * * [[Example 2: Create distance measurements with mouse](https://xeokit.github.io/xeokit-sdk/examples/#measurements_distance_createWithMouse)]
 * * [[Example 3: Configuring units and scale](https://xeokit.github.io/xeokit-sdk/examples/#measurements_distance_unitsAndScale)]
 *
 * ## Overview
 *
 * * A {@link DistanceMeasurement} represents a point-to-point measurement between two 3D points on one or two {@link Entity}s.
 * * As shown on the screen capture above, a DistanceMeasurement has one wire (light blue) that shows the direct point-to-point measurement,
 * and three more wires (red, green and blue) that show the distance on each of the World-space X, Y and Z axis.
 * * Create DistanceMeasurements programmatically with {@link DistanceMeasurementsPlugin#createMeasurement}.
 * * Create DistanceMeasurements interactively using the {@link DistanceMeasurementsControl}, located at {@link DistanceMeasurementsPlugin#control}.
 * * Existing DistanceMeasurements are registered by ID in {@link DistanceMeasurementsPlugin#measurements}.
 * * Destroy DistanceMeasurements using {@link DistanceMeasurementsPlugin#destroyMeasurement}.
 * * Configure global measurement units and scale via {@link Metrics}, located at {@link Scene#metrics}.
 *
 * ## Example 1: Creating DistanceMeasurements Programmatically
 *
 * In our first example, we'll use an {@link XKTLoaderPlugin} to load a model, and then use a DistanceMeasurementsPlugin to programmatically create two {@link DistanceMeasurement}s.
 *
 * Note how each DistanceMeasurement has ````origin```` and ````target```` endpoints, which each indicate a 3D World-space
 * position on the surface of an {@link Entity}. The endpoints can be attached to the same Entity, or to different Entitys.
 *
 * [[Run example](https://xeokit.github.io/xeokit-sdk/examples/#measurements_distance_modelWithMeasurements)]
 *
 * ````JavaScript
 * import {Viewer, XKTLoaderPlugin, DistanceMeasurementsPlugin} from "xeokit-sdk.es.js";
 *
 * const viewer = new Viewer({
 *     canvasId: "myCanvas",
 *     transparent: true
 * });
 *
 * viewer.scene.camera.eye = [-2.37, 18.97, -26.12];
 * viewer.scene.camera.look = [10.97, 5.82, -11.22];
 * viewer.scene.camera.up = [0.36, 0.83, 0.40];
 *
 * const xktLoader = new XKTLoaderPlugin(viewer);
 *
 * const distanceMeasurements = new DistanceMeasurementsPlugin(viewer);
 *
 * const model = xktLoader.load({
 *      src: "./models/xkt/duplex/duplex.xkt"
 * });
 *
 * model.on("loaded", () => {
 *
 *      const myMeasurement1 = distanceMeasurements.createMeasurement({
 *          id: "distanceMeasurement1",
 *          origin: {
 *              entity: viewer.scene.objects["2O2Fr$t4X7Zf8NOew3FLOH"],
 *              worldPos: [0.044, 5.998, 17.767]
 *          },
 *          target: {
 *              entity: viewer.scene.objects["2O2Fr$t4X7Zf8NOew3FLOH"],
 *              worldPos: [4.738, 3.172, 17.768]
 *          },
 *          visible: true,
 *          wireVisible: true
 *      });
 *
 *      const myMeasurement2 = distanceMeasurements.createMeasurement({
 *          id: "distanceMeasurement2",
 *          origin: {
 *              entity: viewer.scene.objects["2O2Fr$t4X7Zf8NOew3FNr2"],
 *              worldPos: [0.457, 2.532, 17.766]
 *          },
 *          target: {
 *              entity: viewer.scene.objects["1CZILmCaHETO8tf3SgGEXu"],
 *              worldPos: [0.436, 0.001, 22.135]
 *          },
 *          visible: true,
 *          wireVisible: true
 *      });
 * });
 * ````
 *
 * ## Example 2: Creating DistanceMeasurements Interactively
 *
 * In our second example, we'll use an {@link XKTLoaderPlugin} to load a model, then we'll use the DistanceMeasurementPlugin's {@link DistanceMeasurementsControl} to interactively create {@link DistanceMeasurement}s with mouse or touch input.
 *
 * After we've activated the DistanceMeasurementsControl, the first click on any {@link Entity} begins constructing a DistanceMeasurement, fixing its
 * origin to that Entity. The next click on any Entity will complete the DistanceMeasurement, fixing its target to that second Entity.
 *
 * The DistanceMeasurementControl will then wait for the next click on any Entity, to begin constructing
 * another DistanceMeasurement, and so on, until deactivated again.
 *
 * [[Run example](https://xeokit.github.io/xeokit-sdk/examples/#measurements_distance_createWithMouse)]
 *
 * ````JavaScript
 * import {Viewer, XKTLoaderPlugin, DistanceMeasurementsPlugin} from "xeokit-sdk.es.js";
 *
 * const viewer = new Viewer({
 *     canvasId: "myCanvas",
 *     transparent: true
 * });
 *
 * viewer.scene.camera.eye = [-2.37, 18.97, -26.12];
 * viewer.scene.camera.look = [10.97, 5.82, -11.22];
 * viewer.scene.camera.up = [0.36, 0.83, 0.40];
 *
 * const xktLoader = new XKTLoaderPlugin(viewer);
 *
 * const distanceMeasurements = new DistanceMeasurementsPlugin(viewer);
 *
 * const model = xktLoader.load({
 *     src: "./models/xkt/duplex/duplex.xkt"
 * });
 *
 * distanceMeasurements.control.activate();  // <------------ Activate the DistanceMeasurementsControl
 * ````
 *
 * ## Example 3: Configuring Measurement Units and Scale
 *
 * In our third example, we'll use the  {@link Scene}'s {@link Metrics} to set the global unit of measurement to ````"meters"````. We'll also specify that a unit within the World-space coordinate system represents ten meters.
 *
 * The wires belonging to our DistanceMeasurements show their lengths in Real-space coordinates, in the current unit of measurement. They will dynamically update as we set these configurations.
 *
 * * [[Run example](https://xeokit.github.io/xeokit-sdk/examples/#measurements_distance_unitsAndScale)]
 *
 * ````JavaScript
 * const metrics = viewer.scene.metrics;

 * metrics.units = "meters";
 * metrics.scale = 10.0;
 * ````
 */

var DistanceMeasurementsPlugin = /*#__PURE__*/function (_Plugin) {
  _inherits(DistanceMeasurementsPlugin, _Plugin);

  var _super = _createSuper(DistanceMeasurementsPlugin);

  /**
   * @constructor
   * @param {Viewer} viewer The Viewer.
   * @param {Object} [cfg]  Plugin configuration.
   * @param {String} [cfg.id="DistanceMeasurements"] Optional ID for this plugin, so that we can find it within {@link Viewer#plugins}.
   * @param {Number} [cfg.labelMinAxisLength=25] The minimum length, in pixels, of an axis wire beyond which its label is shown.
   * @param {HTMLElement} [cfg.container] Container DOM element for markers and labels. Defaults to ````document.body````.
   * @param {boolean} [cfg.defaultVisible=true] The default value of the DistanceMeasurements `visible` property.
   * @param {boolean} [cfg.defaultOriginVisible=true] The default value of the DistanceMeasurements `originVisible` property.
   * @param {boolean} [cfg.defaultTargetVisible=true] The default value of the DistanceMeasurements `targetVisible` property.
   * @param {boolean} [cfg.defaultWireVisible=true] The default value of the DistanceMeasurements `wireVisible` property.
   * @param {boolean} [cfg.defaultAxisVisible=true] The default value of the DistanceMeasurements `axisVisible` property.
   * @param {boolean} [cfg.defaultAxisEnabled=true] The default value of the DistanceMeasurements `axisVisible` property.
   * @param {string} [cfg.defaultColor=#00BBFF] The default color of the length dots, wire and label.
   * @param {number} [cfg.zIndex] If set, the wires, dots and labels will have this zIndex (+1 for dots and +2 for labels).
   */
  function DistanceMeasurementsPlugin(viewer) {
    var _this;

    var cfg = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, DistanceMeasurementsPlugin);

    _this = _super.call(this, "DistanceMeasurements", viewer);
    _this._container = cfg.container || document.body;
    _this._control = new DistanceMeasurementsControl(_assertThisInitialized(_this));
    _this._measurements = {};
    _this.labelMinAxisLength = cfg.labelMinAxisLength;
    _this.defaultVisible = cfg.defaultVisible !== false;
    _this.defaultOriginVisible = cfg.defaultOriginVisible !== false;
    _this.defaultTargetVisible = cfg.defaultTargetVisible !== false;
    _this.defaultWireVisible = cfg.defaultWireVisible !== false;
    _this.defaultAxisVisible = cfg.defaultAxisVisible !== false;
    _this.defaultColor = cfg.defaultColor !== undefined ? cfg.defaultColor : "#00BBFF";
    _this.zIndex = cfg.zIndex || 10000;
    return _this;
  }
  /**
   * @private
   */


  _createClass(DistanceMeasurementsPlugin, [{
    key: "send",
    value: function send(name, value) {}
    /**
     * Gets the {@link DistanceMeasurementsControl}, which creates {@link DistanceMeasurement}s from user input.
     *
     * @type {DistanceMeasurementsControl}
     */

  }, {
    key: "control",
    get: function get() {
      return this._control;
    }
    /**
     * Gets the existing {@link DistanceMeasurement}s, each mapped to its {@link DistanceMeasurement#id}.
     *
     * @type {{String:DistanceMeasurement}}
     */

  }, {
    key: "measurements",
    get: function get() {
      return this._measurements;
    }
    /**
     * Sets the minimum length, in pixels, of an axis wire beyond which its label is shown.
     *
     * The axis wire's label is not shown when its length is less than this value.
     *
     * This is ````25```` pixels by default.
     *
     * Must not be less than ````1````.
     *
     * @type {number}
     */

  }, {
    key: "labelMinAxisLength",
    get:
    /**
     * Gets the minimum length, in pixels, of an axis wire beyond which its label is shown.
     * @returns {number}
     */
    function get() {
      return this._labelMinAxisLength;
    }
    /**
     * Creates a {@link DistanceMeasurement}.
     *
     * The DistanceMeasurement is then registered by {@link DistanceMeasurement#id} in {@link DistanceMeasurementsPlugin#measurements}.
     *
     * @param {Object} params {@link DistanceMeasurement} configuration.
     * @param {String} params.id Unique ID to assign to {@link DistanceMeasurement#id}. The DistanceMeasurement will be registered by this in {@link DistanceMeasurementsPlugin#measurements} and {@link Scene.components}. Must be unique among all components in the {@link Viewer}.
     * @param {Number[]} params.origin.worldPos Origin World-space 3D position.
     * @param {Entity} params.origin.entity Origin Entity.
     * @param {Number[]} params.target.worldPos Target World-space 3D position.
     * @param {Entity} params.target.entity Target Entity.
     * @param {Boolean} [params.visible=true] Whether to initially show the {@link DistanceMeasurement}.
     * @param {Boolean} [params.originVisible=true] Whether to initially show the {@link DistanceMeasurement} origin.
     * @param {Boolean} [params.targetVisible=true] Whether to initially show the {@link DistanceMeasurement} target.
     * @param {Boolean} [params.wireVisible=true] Whether to initially show the direct point-to-point wire between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target}.
     * @param {Boolean} [params.axisVisible=true] Whether to initially show the axis-aligned wires between {@link DistanceMeasurement#origin} and {@link DistanceMeasurement#target}.
     * @param {string} [params.color] The color of the length dot, wire and label.
     * @returns {DistanceMeasurement} The new {@link DistanceMeasurement}.
     */
    ,
    set: function set(labelMinAxisLength) {
      if (labelMinAxisLength < 1) {
        this.error("labelMinAxisLength must be >= 1; defaulting to 25");
        labelMinAxisLength = 25;
      }

      this._labelMinAxisLength = labelMinAxisLength || 25;
    }
  }, {
    key: "createMeasurement",
    value: function createMeasurement() {
      var _this2 = this;

      var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (this.viewer.scene.components[params.id]) {
        this.error("Viewer scene component with this ID already exists: " + params.id);
        delete params.id;
      }

      var origin = params.origin;
      var target = params.target;
      var measurement = new DistanceMeasurement(this, {
        id: params.id,
        plugin: this,
        container: this._container,
        origin: {
          entity: origin.entity,
          worldPos: origin.worldPos
        },
        target: {
          entity: target.entity,
          worldPos: target.worldPos
        },
        visible: params.visible,
        wireVisible: params.wireVisible,
        axisVisible: params.axisVisible !== false && this.defaultAxisVisible !== false,
        originVisible: params.originVisible,
        targetVisible: params.targetVisible,
        color: params.color
      });
      this._measurements[measurement.id] = measurement;
      measurement.on("destroyed", function () {
        delete _this2._measurements[measurement.id];
      });
      this.fire("measurementCreated", measurement);
      return measurement;
    }
    /**
     * Destroys a {@link DistanceMeasurement}.
     *
     * @param {String} id ID of DistanceMeasurement to destroy.
     */

  }, {
    key: "destroyMeasurement",
    value: function destroyMeasurement(id) {
      var measurement = this._measurements[id];

      if (!measurement) {
        this.log("DistanceMeasurement not found: " + id);
        return;
      }

      measurement.destroy();
      this.fire("measurementDestroyed", measurement);
    }
    /**
     * Destroys all {@link DistanceMeasurement}s.
     */

  }, {
    key: "clear",
    value: function clear() {
      var ids = Object.keys(this._measurements);

      for (var i = 0, len = ids.length; i < len; i++) {
        this.destroyMeasurement(ids[i]);
      }
    }
    /**
     * Destroys this DistanceMeasurementsPlugin.
     *
     * Destroys all {@link DistanceMeasurement}s first.
     */

  }, {
    key: "destroy",
    value: function destroy() {
      this.clear();

      _get(_getPrototypeOf(DistanceMeasurementsPlugin.prototype), "destroy", this).call(this);
    }
  }]);

  return DistanceMeasurementsPlugin;
}(ctXeokitViewer.Plugin);

exports.DistanceMeasurementsPlugin = DistanceMeasurementsPlugin;
//# sourceMappingURL=distance-measurements.cjs.js.map
